﻿"Filed out from Dolphin Smalltalk 7"!

UMLToolShell subclass: #UMLIdeaSpaceShell
	instanceVariableNames: 'cardPresenter'
	classVariableNames: ''
	poolDictionaries: ''
	classInstanceVariableNames: ''!
UMLIdeaSpaceShell guid: (GUID fromString: '{9e0ffb6c-65e1-4bb3-84f1-ce83dd583a05}')!
UMLIdeaSpaceShell comment: ''!
!UMLIdeaSpaceShell categoriesForClass!MVP-Resources-UFabrik! !
!UMLIdeaSpaceShell methodsFor!

checkSelectedMethod
	^self currentCardPresenter checkSelectedMethod!

closeCurrentUMLCard
	| browser |

	self hasCurrentCard ifFalse: [^self].
	browser := self currentCardPresenter.
	self developmentEnvironment unregisterUMLTool: browser mainComposite.
	cardPresenter remove: browser.

	!

createComponents

	super createComponents.

	cardPresenter := self add: Presenter new name: 'card'.!

createSchematicWiring

	super createSchematicWiring.

	cardPresenter view when: #currentCardChanged send: #onCardChanged to: self!

currentCardPresenter

	cardPresenter view cards isEmpty ifTrue: [^nil].

	^cardPresenter view currentCard presenter!

hasCurrentCard

	^cardPresenter view currentCard notNil!

hasSelectedClass
	^self currentCardPresenter hasSelectedClass!

hasSelectedImplementation
	^self currentCardPresenter hasSelectedImplementation!

isClassSideSelected

	^self currentCardPresenter isClassSideSelected!

isIdeaSpace

	^true!

mainComposite

	^self currentCardPresenter ifNotNil: [:value | value mainComposite] ifNil: [nil] !

model

	cardPresenter view currentCard ifNil: [^nil].
	^self currentCardPresenter model!

model: aModel

	^self currentCardPresenter model: aModel!

moveCardLeft
	| cardView previuosSibling currentPresenterView |

	cardView := cardPresenter view .
	(cardView cards isEmpty or:[cardView cards size = 1]) ifTrue: [^nil].

	currentPresenterView := self currentCardPresenter view.
	previuosSibling := currentPresenterView previousSiblingView.

	previuosSibling notNil ifTrue: [previuosSibling zOrderAfter: currentPresenterView] ifFalse: [currentPresenterView zOrderTop].



!

moveCardRight
	| cardView nextSibling currentPresenterView |

	cardView := cardPresenter view .
	(cardView cards isEmpty or:[cardView cards size = 1]) ifTrue: [^nil].

	currentPresenterView := self currentCardPresenter view.
	nextSibling  := currentPresenterView nextSiblingView.

	nextSibling notNil ifTrue: [currentPresenterView zOrderAfter: nextSibling] ifFalse: [currentPresenterView zOrderTop].!

onCardChanged

	self hasCurrentCard ifFalse: [^self].

	[view menuBar: self currentCardPresenter menuBar] forkAt: 4!

onClassChanged
	^self currentCardPresenter onClassChanged!

onClassListChanged
	^self currentCardPresenter onClassListChanged!

onUMLModelClassChanged

	^self currentCardPresenter onUMLModelClassChanged!

openCategoryBrowser
	| browser |

	browser := UMLCategoryBrowser createIn: cardPresenter on: self defaultVirtualMachine getAllCategories.
	browser view arrangement: (CardLabel text: 'Category Browser' iconBlock: [UMLCategoryBrowserShell icon]).

	self developmentEnvironment registerUMLTool: browser mainComposite.
!

openTraitBrowser
	| browser |

	browser := UMLTraitBrowserComposite createIn: cardPresenter on: self defaultVirtualMachine.
	browser view arrangement: (CardLabel text: 'Trait Browser' iconBlock: [UMLTraitBrowserShell icon]).

	self developmentEnvironment registerUMLTool: browser mainComposite.!

openUMLBrowser
	| browser |

	browser := UMLModelBrowser createIn: cardPresenter on: (self defaultVirtualMachine umlModels asSortedCollection: [:a :b | a name <= b name]).
	browser view arrangement: (CardLabel text: 'UML Browser' iconBlock: [UMLModel icon]).

	self developmentEnvironment registerUMLTool: browser mainComposite.
!

openUMLWorkspace
	| browser |

	browser := UMLBasicWorkspaceComposite createIn: cardPresenter on: self defaultVirtualMachine.
	browser view arrangement: (CardLabel text: 'UML Script' iconBlock: [UMLWorkspaceShell icon])!

openVirtualMachineBrowser
	| browser |

	browser := UMLVirtualMachineBrowser createIn: cardPresenter on: self defaultVirtualMachine.
	browser view arrangement: (CardLabel text: 'Virtual Machine' iconBlock: [UMLVirtualMachine icon])!

selectClass: anUMLClass 
	^self currentCardPresenter selectClass: anUMLClass!

selectClass: anUMLClass ifAbsent: aNiladicValuable 
	^self currentCardPresenter selectClass: anUMLClass ifAbsent: aNiladicValuable !

selectedClass

	^cardPresenter view currentCard presenter selectedClass!

selectedClassDescription
	^self currentCardPresenter selectedClassDescription!

selectedModel
	^self currentCardPresenter selectedModel!

selectedObject

	^self defaultVirtualMachine nilObject!

selectImplementation: anUMLParsedImplementation 

	^self currentCardPresenter selectImplementation: anUMLParsedImplementation !

selectUMLClass: anUMLClass ifAbsent: aNiladicValuable
	^self currentCardPresenter selectUMLClass: anUMLClass ifAbsent: aNiladicValuable!

selectUMLModel: anUMLModel ifAbsent: aNiladicValuable 

	^self currentCardPresenter selectModel: anUMLModel ifAbsent: aNiladicValuable! !
!UMLIdeaSpaceShell categoriesFor: #checkSelectedMethod!public! !
!UMLIdeaSpaceShell categoriesFor: #closeCurrentUMLCard!public! !
!UMLIdeaSpaceShell categoriesFor: #createComponents!public! !
!UMLIdeaSpaceShell categoriesFor: #createSchematicWiring!public! !
!UMLIdeaSpaceShell categoriesFor: #currentCardPresenter!public! !
!UMLIdeaSpaceShell categoriesFor: #hasCurrentCard!public! !
!UMLIdeaSpaceShell categoriesFor: #hasSelectedClass!public! !
!UMLIdeaSpaceShell categoriesFor: #hasSelectedImplementation!public! !
!UMLIdeaSpaceShell categoriesFor: #isClassSideSelected!public! !
!UMLIdeaSpaceShell categoriesFor: #isIdeaSpace!public! !
!UMLIdeaSpaceShell categoriesFor: #mainComposite!public! !
!UMLIdeaSpaceShell categoriesFor: #model!public! !
!UMLIdeaSpaceShell categoriesFor: #model:!public! !
!UMLIdeaSpaceShell categoriesFor: #moveCardLeft!public! !
!UMLIdeaSpaceShell categoriesFor: #moveCardRight!public! !
!UMLIdeaSpaceShell categoriesFor: #onCardChanged!public! !
!UMLIdeaSpaceShell categoriesFor: #onClassChanged!public! !
!UMLIdeaSpaceShell categoriesFor: #onClassListChanged!public! !
!UMLIdeaSpaceShell categoriesFor: #onUMLModelClassChanged!public! !
!UMLIdeaSpaceShell categoriesFor: #openCategoryBrowser!public! !
!UMLIdeaSpaceShell categoriesFor: #openTraitBrowser!public! !
!UMLIdeaSpaceShell categoriesFor: #openUMLBrowser!public! !
!UMLIdeaSpaceShell categoriesFor: #openUMLWorkspace!public! !
!UMLIdeaSpaceShell categoriesFor: #openVirtualMachineBrowser!public! !
!UMLIdeaSpaceShell categoriesFor: #selectClass:!public! !
!UMLIdeaSpaceShell categoriesFor: #selectClass:ifAbsent:!public! !
!UMLIdeaSpaceShell categoriesFor: #selectedClass!public! !
!UMLIdeaSpaceShell categoriesFor: #selectedClassDescription!public! !
!UMLIdeaSpaceShell categoriesFor: #selectedModel!public! !
!UMLIdeaSpaceShell categoriesFor: #selectedObject!public! !
!UMLIdeaSpaceShell categoriesFor: #selectImplementation:!public! !
!UMLIdeaSpaceShell categoriesFor: #selectUMLClass:ifAbsent:!public! !
!UMLIdeaSpaceShell categoriesFor: #selectUMLModel:ifAbsent:!public! !

!UMLIdeaSpaceShell class methodsFor!

icon

	^Icon fromId: 'IdeaSpaceShell.ico'!

resource_Default_view
	"Answer the literal data from which the 'Default view' resource can be reconstituted.
	DO NOT EDIT OR RECATEGORIZE THIS METHOD.

	If you wish to modify this resource evaluate:
	ViewComposer openOn: (ResourceIdentifier class: self selector: #resource_Default_view)
	"

	^#(#'!!STL' 3 788558 10 ##(Smalltalk.STBViewProxy)  8 ##(Smalltalk.ShellView)  98 27 0 0 98 2 27131905 131073 416 0 721158 ##(Smalltalk.SystemColor)  31 0 551 0 0 0 416 788230 ##(Smalltalk.BorderLayout)  1 1 410 8 ##(Smalltalk.ContainerView)  98 15 0 416 98 2 8 1140850688 131073 544 0 482 31 0 7 0 0 0 544 852230 ##(Smalltalk.FramingLayout)  234 240 98 6 410 8 ##(Smalltalk.ReferenceView)  98 14 0 544 98 2 8 1140850688 131073 704 0 524550 ##(Smalltalk.ColorRef)  8 4278190080 0 7 0 0 0 704 1180166 ##(Smalltalk.ResourceIdentifier)  8 ##(Smalltalk.Toolbar)  8 #resource_UML_Common 0 983302 ##(Smalltalk.MessageSequence)  202 208 98 1 721670 ##(Smalltalk.MessageSend)  8 #createAt:extent: 98 2 328198 ##(Smalltalk.Point)  5 1 1026 611 51 704 983302 ##(Smalltalk.WINDOWPLACEMENT)  8 #[44 0 0 0 0 0 0 0 1 0 0 0 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 2 0 0 0 0 0 0 0 51 1 0 0 25 0 0 0] 98 0 1026 193 193 0 27 1181766 2 ##(Smalltalk.FramingConstraints)  1180678 ##(Smalltalk.FramingCalculation)  8 #fixedParentLeft 5 1200 615 1186 8 #fixedParentTop 1 1186 8 #fixedParentBottom 1 410 864 98 25 0 544 98 2 8 1409288972 131137 1296 0 786 8 4278190080 0 519 0 263174 ##(Smalltalk.Font)  0 16 459014 ##(Smalltalk.LOGFONT)  8 #[243 255 255 255 0 0 0 0 0 0 0 0 0 0 0 0 144 1 0 0 0 0 0 0 3 2 1 34 65 114 105 97 108 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0] 1026 193 193 0 1296 786 1376 8 4294902785 234 256 1120 234 256 98 6 29021 853766 ##(Smalltalk.ToolbarButton)  29021 0 1296 1 1180998 4 ##(Smalltalk.CommandDescription)  8 #moveCardLeft 8 'Mode Card Left' 1 1 0 657990 3 ##(Smalltalk.DIBSection)  0 16 1572870 ##(Smalltalk.ImageRelativeFileLocator)  8 'IdeaSpaceCardBar.bmp' 0 0 7 1026 161 33 17 0 1 29023 1570 29023 0 1296 1 1602 8 #moveCardRight 8 'Move Card Right' 1 1 0 1680 3 29025 1570 29025 0 1296 1 1602 8 #closeCurrentUMLCard 8 'No command' 1 1 0 1680 5 98 3 1584 1760 1824 234 240 98 2 1680 1 0 1 0 1026 33 33 1026 45 45 0 656198 1 ##(Smalltalk.FlowLayout)  1 1 1 898 202 208 98 2 962 992 98 2 1026 1785 1 1026 175 51 1296 962 8 #updateSize 1120 1296 1074 8 #[44 0 0 0 0 0 0 0 1 0 0 0 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 124 3 0 0 0 0 0 0 211 3 0 0 25 0 0 0] 98 0 1136 0 27 1154 1186 8 #fixedParentRight -173 2208 1 1232 1 1264 1 410 864 98 25 0 544 98 2 8 1409288972 131137 2240 0 786 8 4278190080 0 519 0 1394 0 16 1426 8 #[243 255 255 255 0 0 0 0 0 0 0 0 0 0 0 0 144 1 0 0 0 0 0 0 3 2 1 34 65 114 105 97 108 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0] 1026 193 193 0 2240 786 2320 8 4294902785 234 256 1120 234 256 1120 202 208 1120 234 240 1120 0 1 0 1026 33 33 1026 45 45 0 1970 1 1 1 898 202 208 98 2 962 992 98 2 1026 595 1 1026 1191 51 2240 962 2128 1120 2240 1074 8 #[44 0 0 0 0 0 0 0 1 0 0 0 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 41 1 0 0 0 0 0 0 124 3 0 0 25 0 0 0] 98 0 1136 0 27 1154 1200 595 2208 -173 1232 1 1264 1 234 256 1120 0 898 202 208 98 1 962 992 98 2 1026 1 1 1026 1959 51 544 1074 8 #[44 0 0 0 0 0 0 0 1 0 0 0 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 0 0 0 0 0 0 0 0 211 3 0 0 25 0 0 0] 98 3 704 1296 2240 1136 0 27 0 0 0 410 8 ##(Smalltalk.CardContainer)  98 16 0 416 98 2 8 1409286144 131073 2912 0 482 31 0 7 0 0 0 2912 655878 ##(Smalltalk.CardLayout)  202 208 1120 0 234 256 1120 0 410 8 ##(Smalltalk.TabViewXP)  98 28 0 2912 98 2 8 1140916736 1 3072 590662 2 ##(Smalltalk.ListModel)  202 208 1120 0 1310726 ##(Smalltalk.IdentitySearchPolicy)  2992 0 1 0 0 0 3072 0 8 4294902889 787814 3 ##(Smalltalk.BlockClosure)  0 0 918822 ##(Smalltalk.CompiledMethod)  2 3 8 ##(Smalltalk.ListControlView)  8 #defaultGetTextBlock 575230339 8 #[30 105 226 0 106] 8 #displayString 3264 7 257 0 3250 0 0 3282 2 3 8 ##(Smalltalk.IconicListAbstract)  8 #defaultGetImageBlock 579598755 8 #[30 105 226 0 106] 8 #iconImageIndex 3376 7 257 0 1049670 1 ##(Smalltalk.IconImageManager)  0 0 0 0 0 8 #smallIcons 0 0 0 0 0 898 202 208 98 2 962 992 98 2 1026 1 1 1026 1959 1125 3072 962 8 #tcmSetExtendedStyle:dwExStyle: 98 2 -1 1 3072 1074 8 #[44 0 0 0 0 0 0 0 1 0 0 0 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 0 0 0 0 0 0 0 0 211 3 0 0 50 2 0 0] 98 0 1136 0 27 898 202 208 98 1 962 992 98 2 1026 1 51 1026 1959 1125 2912 1074 8 #[44 0 0 0 0 0 0 0 1 0 0 0 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 0 0 0 0 25 0 0 0 211 3 0 0 75 2 0 0] 98 1 3072 1136 0 27 234 256 98 2 2912 8 'card' 0 461638 4 ##(Smalltalk.MenuBar)  0 16 98 2 265030 4 ##(Smalltalk.Menu)  0 16 98 2 983366 1 ##(Smalltalk.DividerMenuItem)  4097 984134 2 ##(Smalltalk.CommandMenuItem)  1 1602 8 #exit 8 'Exit' 1 1 0 0 0 8 'File' 0 134217729 0 0 28979 0 0 3986 0 16 98 15 4066 1 1602 8 #openUMLIdeaSpace 8 'Idea Space' 1 1 263494 3 ##(Smalltalk.Icon)  0 16 1712 8 'IdeaSpaceShell.ico' 2032142 ##(Smalltalk.STBExternalResourceLibraryProxy)  8 'dolphindr006.dll' 0 0 0 4066 1 1602 8 #openUMLBrowser 8 'UML Model Browser' 1 1 786694 ##(Smalltalk.InternalIcon)  852742 ##(Smalltalk.GdiplusBitmap)  0 16 2097670 ##(Smalltalk.GdiplusImageFromBytesInitializer)  0 8 #[137 80 78 71 13 10 26 10 0 0 0 13 73 72 68 82 0 0 0 32 0 0 0 32 8 6 0 0 0 115 122 122 244 0 0 0 1 115 82 71 66 0 174 206 28 233 0 0 0 4 103 65 77 65 0 0 177 143 11 252 97 5 0 0 0 32 99 72 82 77 0 0 122 38 0 0 128 132 0 0 250 0 0 0 128 232 0 0 117 48 0 0 234 96 0 0 58 152 0 0 23 112 156 186 81 60 0 0 9 248 73 68 65 84 88 71 157 87 9 120 141 87 26 62 247 222 108 34 150 88 166 180 67 41 170 212 86 123 18 109 233 44 143 122 234 25 243 212 214 17 98 173 61 72 132 196 86 90 83 29 211 193 152 142 45 137 132 220 216 90 26 202 24 75 45 99 9 177 134 218 141 160 37 33 150 144 220 245 95 222 121 207 185 55 151 232 211 169 153 115 159 239 249 255 123 254 255 156 239 253 150 247 251 254 99 1 135 224 240 95 228 237 127 25 16 242 103 181 216 124 239 232 66 156 217 151 43 106 215 173 35 234 190 222 80 77 121 96 138 96 110 105 225 174 134 205 42 172 156 179 154 190 215 193 63 82 153 124 38 135 197 98 81 138 255 175 113 237 64 62 178 122 79 197 95 170 118 197 162 87 122 226 159 179 150 193 117 167 228 127 222 43 0 192 52 77 252 188 0 165 69 37 88 210 63 9 67 68 67 76 16 77 145 108 235 136 137 162 21 198 139 198 152 17 222 30 27 227 102 225 198 137 139 48 253 80 188 188 115 82 228 213 212 13 152 198 19 61 202 251 229 144 169 191 2 0 57 175 54 121 106 94 231 98 175 102 226 254 245 34 236 91 180 22 159 182 238 75 16 205 49 89 180 192 76 209 17 41 226 13 254 127 13 41 33 29 176 129 222 185 114 224 68 192 35 30 185 149 102 0 92 95 110 168 15 128 31 170 1 141 15 12 240 149 10 67 62 214 57 47 159 153 134 14 183 161 65 110 38 135 187 204 141 195 171 183 224 79 111 13 195 8 42 31 75 48 211 69 123 76 21 109 16 47 94 225 245 85 44 235 57 10 23 118 30 86 239 203 189 168 165 34 0 105 149 122 104 60 14 40 254 225 216 89 172 79 254 51 242 190 222 25 0 100 114 169 161 185 185 88 231 157 78 151 62 129 234 230 22 199 182 236 199 210 95 143 194 56 107 43 12 163 226 9 214 54 202 51 99 8 100 156 104 134 197 191 29 137 162 203 55 125 186 252 225 246 121 64 123 164 38 53 202 213 221 199 144 213 103 18 198 87 142 194 72 209 72 109 52 247 173 1 56 188 102 59 116 167 124 195 55 116 90 33 45 225 78 210 61 48 232 157 242 61 242 15 30 199 194 223 143 85 74 39 88 219 98 162 181 51 18 69 7 196 137 6 152 210 164 59 30 22 20 5 64 40 0 30 46 46 252 254 33 62 238 54 129 110 108 204 24 190 132 4 186 112 42 99 58 93 180 195 36 38 218 8 2 249 184 109 95 236 95 145 3 215 35 119 0 136 135 222 112 49 36 186 73 242 81 188 10 154 111 28 200 200 65 98 68 23 76 8 138 193 100 107 20 82 108 29 48 72 212 67 94 214 182 192 122 5 192 107 184 225 44 204 199 137 149 243 177 172 215 120 12 183 189 205 88 54 166 251 218 34 153 200 103 16 200 44 2 153 194 228 26 41 154 96 102 211 223 97 207 231 217 100 195 67 159 37 20 149 57 6 165 92 59 231 174 236 61 129 164 234 49 72 9 141 198 28 75 52 115 162 41 198 214 137 194 189 43 63 84 4 0 179 24 200 27 14 125 247 155 208 10 210 112 105 207 65 124 57 108 14 166 132 119 163 229 45 48 77 180 68 178 181 35 102 90 219 225 51 122 70 38 89 60 105 55 167 97 47 108 155 185 20 133 249 23 25 63 61 16 156 194 179 151 177 45 97 33 102 70 198 32 137 108 152 99 233 72 67 26 97 90 221 46 56 183 243 80 5 247 43 15 232 100 41 142 246 135 182 82 192 155 97 131 123 199 187 208 174 255 13 5 121 223 194 30 191 24 243 106 117 162 194 122 228 121 27 204 178 180 164 71 218 97 58 55 157 202 235 68 198 121 118 72 20 150 183 24 140 204 110 31 226 139 246 239 99 74 149 24 38 94 43 82 178 45 189 214 28 19 45 173 145 17 155 132 123 151 190 87 202 61 38 115 233 233 36 52 81 70 0 131 224 182 135 67 207 18 48 82 5 220 127 39 59 143 14 81 11 238 220 44 196 150 217 159 35 161 81 47 140 38 213 38 115 211 120 134 99 92 104 51 76 10 121 131 74 58 17 92 71 53 151 200 68 155 68 80 163 41 147 171 118 66 118 108 10 10 254 117 198 167 152 82 230 113 65 243 242 206 95 91 148 7 96 48 4 135 123 195 181 58 2 158 44 43 60 246 96 120 87 9 232 27 154 194 233 190 17 224 188 163 248 1 14 165 230 96 97 143 20 36 215 250 13 146 24 158 120 42 28 77 25 69 170 77 12 122 21 31 213 127 19 246 254 211 144 155 186 9 69 87 111 60 33 170 84 72 182 72 250 177 154 60 83 7 192 250 125 164 31 204 140 80 152 12 131 158 17 70 32 193 40 205 170 3 239 173 237 128 151 188 103 126 57 110 229 192 115 118 14 204 210 99 40 185 115 29 23 114 207 225 200 134 189 56 146 189 21 199 115 118 49 185 174 194 227 112 97 23 123 196 31 23 102 67 114 197 75 209 201 20 157 9 106 200 122 227 151 10 117 192 52 74 153 132 189 160 173 10 2 210 131 224 181 243 186 202 2 239 138 96 56 47 44 82 85 92 110 230 220 63 138 161 9 134 123 245 203 112 29 249 3 116 199 233 10 217 188 255 240 121 244 232 55 155 125 174 7 94 107 153 200 194 230 163 136 172 160 146 156 82 148 226 31 245 2 157 133 232 104 47 120 87 91 129 53 53 224 248 166 33 116 222 27 233 2 37 135 125 121 160 105 197 40 221 210 9 200 136 0 150 87 133 59 77 160 208 254 75 56 246 197 162 248 106 62 122 190 183 128 138 99 41 253 41 67 16 29 253 169 31 156 44 225 63 221 228 84 14 152 38 75 112 110 127 24 153 76 135 175 234 163 236 80 31 134 160 26 12 38 100 233 150 22 44 248 6 220 133 123 81 182 38 2 186 61 12 198 202 72 122 170 54 32 223 207 14 193 217 29 139 33 42 13 228 71 66 60 44 97 35 9 96 32 186 116 152 243 252 0 116 9 224 96 28 192 248 59 54 53 69 217 133 121 112 172 173 11 125 13 189 176 170 50 140 146 124 184 78 207 131 150 110 161 194 80 206 69 192 157 89 139 185 82 3 200 174 139 11 7 23 160 114 189 1 16 193 67 33 194 120 21 253 208 169 237 236 64 77 250 89 15 120 77 38 225 193 17 10 192 131 141 205 224 186 189 25 142 156 102 42 17 189 203 67 224 184 252 9 28 187 251 144 158 4 147 81 149 239 213 128 115 29 115 36 155 33 203 106 140 75 251 86 161 74 157 177 16 54 74 8 65 136 15 16 211 101 182 159 1 178 79 48 9 41 242 170 186 45 67 66 66 168 208 168 16 120 113 143 44 32 128 12 129 187 95 55 128 183 228 60 28 123 123 208 66 11 28 43 105 45 193 56 179 27 211 245 225 112 103 87 131 119 107 20 92 89 225 208 24 34 216 27 224 226 30 59 170 213 25 71 235 7 81 70 168 16 68 117 73 9 120 128 170 153 196 254 238 201 4 52 76 175 236 171 170 143 249 43 225 125 38 97 28 105 40 112 127 99 3 232 101 87 225 202 79 134 39 35 8 122 102 21 232 105 44 80 233 252 202 91 33 224 249 166 61 28 185 195 225 200 168 196 80 132 209 3 47 226 226 206 116 84 175 77 235 43 13 38 128 15 9 32 14 81 49 211 252 0 88 245 100 139 96 165 86 172 96 227 2 100 247 125 210 89 133 137 135 4 208 91 1 40 93 223 8 102 217 53 56 111 109 70 217 234 170 180 154 46 207 160 114 38 156 182 140 165 58 111 2 156 103 231 194 189 82 82 182 50 89 83 27 151 118 164 162 122 228 120 186 159 0 66 36 128 193 136 138 158 238 79 66 118 74 221 205 234 231 134 161 171 170 160 230 29 165 30 164 166 109 67 124 194 124 249 69 68 68 121 61 25 95 1 231 154 38 48 202 174 195 227 42 128 99 227 203 12 195 11 84 30 198 120 11 60 180 147 25 183 214 195 113 110 62 60 164 40 210 233 157 13 213 232 129 52 84 171 54 145 73 56 132 34 89 48 4 111 119 157 133 99 167 174 97 243 246 83 120 240 216 17 80 92 116 175 4 11 254 154 131 230 45 19 248 222 123 104 221 121 50 105 104 208 3 199 223 1 200 109 215 186 166 240 62 186 193 210 227 64 217 206 174 48 211 35 88 152 194 9 46 8 37 95 53 164 21 183 225 62 243 49 180 52 50 132 165 219 220 80 3 231 119 165 162 178 4 96 27 8 139 85 38 225 48 116 235 246 17 114 143 159 195 174 111 143 170 80 92 187 89 140 148 89 118 212 111 56 137 207 251 82 152 47 98 4 58 199 204 37 0 157 205 33 127 4 52 54 160 199 155 104 213 35 95 133 115 30 157 4 35 141 213 112 45 185 191 204 6 109 87 47 181 153 231 228 116 104 43 66 225 101 93 192 186 154 56 191 59 21 225 145 4 96 141 37 128 56 21 130 119 126 53 87 237 113 245 202 109 36 36 102 162 230 11 99 252 69 42 22 214 160 209 188 31 69 233 142 232 78 137 108 199 50 67 188 215 224 202 155 135 155 187 186 195 83 234 235 217 174 43 89 112 101 214 132 177 150 84 100 14 184 79 103 170 121 207 201 20 104 169 4 96 47 7 176 2 149 34 227 233 1 90 111 29 6 139 24 138 230 45 146 16 55 116 49 42 85 146 33 233 205 83 202 96 88 131 165 82 153 35 125 16 22 214 7 3 98 63 195 169 83 255 230 39 153 170 244 190 161 57 139 85 217 149 57 234 126 112 18 165 235 94 103 14 4 227 254 186 234 240 20 93 246 121 224 68 50 67 16 10 55 169 136 117 181 112 110 247 10 132 214 160 133 65 84 96 163 88 36 21 63 160 188 171 138 146 176 146 162 130 44 161 226 26 213 7 98 220 184 165 200 207 47 8 232 100 251 243 43 103 220 213 61 181 203 66 161 27 247 225 218 211 23 222 47 34 112 127 27 243 65 123 172 138 139 155 30 240 166 86 161 7 170 0 235 171 243 43 103 25 66 34 37 0 186 214 70 139 109 100 131 85 90 74 175 144 146 82 113 221 151 198 96 250 140 44 20 20 220 10 40 150 159 248 114 60 57 23 168 15 75 249 237 239 235 154 242 44 0 207 37 56 46 172 68 201 165 47 249 140 95 78 28 142 211 83 224 73 253 5 43 34 123 194 250 96 156 217 189 4 97 85 73 67 105 185 141 138 109 195 85 49 18 98 0 154 55 79 194 194 133 91 81 84 252 212 145 141 133 72 233 41 175 132 229 144 158 61 25 169 67 12 31 202 26 38 79 2 154 127 129 139 30 144 221 80 22 38 172 125 17 167 247 165 33 56 114 24 21 74 197 180 94 188 143 232 152 120 172 94 179 3 165 46 73 65 57 100 13 160 72 163 101 81 170 112 46 240 191 242 108 211 96 5 81 161 144 25 226 81 199 35 246 117 94 61 15 115 81 186 119 48 30 219 107 147 9 204 129 29 75 148 181 210 213 61 122 206 192 214 173 121 1 55 203 27 221 240 208 163 220 133 150 171 47 231 159 58 27 86 88 245 60 127 204 35 192 229 249 184 123 234 31 152 154 152 141 239 190 187 251 60 171 126 244 206 127 0 30 172 252 189 189 221 143 246 0 0 0 0 73 69 78 68 174 66 96 130] 0 0 4034 4097 4066 1 1602 8 #openCategoryBrowser 8 'Category Browser' 1 1 4418 4450 0 16 4482 0 8 #[137 80 78 71 13 10 26 10 0 0 0 13 73 72 68 82 0 0 0 32 0 0 0 32 8 6 0 0 0 115 122 122 244 0 0 0 1 115 82 71 66 0 174 206 28 233 0 0 0 4 103 65 77 65 0 0 177 143 11 252 97 5 0 0 0 32 99 72 82 77 0 0 122 38 0 0 128 132 0 0 250 0 0 0 128 232 0 0 117 48 0 0 234 96 0 0 58 152 0 0 23 112 156 186 81 60 0 0 0 9 112 72 89 115 0 0 2 19 0 0 2 37 1 19 207 115 49 0 0 8 169 73 68 65 84 88 71 165 151 247 83 148 215 26 199 81 102 252 221 127 226 206 77 204 53 137 73 70 69 133 96 67 165 136 149 128 26 21 20 148 34 224 210 164 139 8 136 136 1 164 73 85 164 72 17 69 20 251 85 99 16 165 8 203 178 176 133 165 44 109 89 88 202 210 203 126 239 115 94 64 193 197 54 247 204 124 231 188 237 60 231 243 148 115 246 236 18 80 211 249 76 27 30 30 209 105 106 110 209 89 186 116 233 123 233 234 46 213 209 93 178 100 230 158 174 89 175 171 171 171 179 108 217 50 157 229 203 151 127 206 156 246 59 6 240 169 54 61 61 141 94 85 31 4 117 245 168 229 36 4 95 48 171 218 58 240 231 169 134 47 64 157 176 30 170 190 254 207 153 212 122 167 243 241 147 254 254 126 200 154 154 209 208 32 70 117 13 31 207 254 251 2 13 34 9 68 36 214 191 23 189 175 159 39 97 189 24 18 105 19 90 90 229 80 171 213 128 230 235 56 180 0 148 74 37 106 201 75 38 230 225 139 151 175 8 168 229 189 26 101 205 152 47 105 99 19 102 212 140 230 150 86 40 104 124 11 245 163 35 163 95 69 160 5 192 232 153 247 204 83 97 189 8 255 148 190 134 188 173 125 129 90 229 109 104 149 183 147 183 109 243 36 71 139 92 142 222 62 21 186 186 9 162 181 29 19 19 19 95 132 208 2 96 131 100 179 94 74 164 50 188 45 175 128 162 187 155 164 224 212 69 234 84 80 175 80 162 179 171 27 29 157 10 180 119 116 161 173 189 131 0 90 161 234 87 17 68 31 247 142 129 79 77 77 125 22 66 11 64 163 209 64 78 222 49 15 155 155 91 81 205 231 147 209 190 5 234 81 169 160 236 153 81 119 79 207 172 148 144 52 74 233 90 201 125 203 34 209 222 217 69 128 157 96 197 252 169 166 5 192 62 100 117 192 60 109 239 236 128 80 40 196 192 224 32 6 212 36 234 251 6 250 57 125 12 197 238 229 109 109 220 24 54 86 161 236 70 55 137 221 15 178 162 252 68 91 20 96 144 38 98 30 48 35 34 177 8 234 65 53 216 179 193 129 1 12 124 73 180 138 216 74 98 154 251 118 108 108 236 219 0 134 135 135 57 111 123 40 188 82 10 43 43 76 6 241 30 132 193 124 36 245 34 207 230 190 25 31 31 255 54 128 209 209 81 110 2 150 10 153 76 54 3 240 127 104 144 10 115 122 114 108 209 173 97 145 34 156 134 154 114 204 242 214 77 213 223 210 210 50 235 237 108 20 184 104 12 126 1 136 189 31 226 190 233 239 233 68 193 95 110 120 28 237 136 126 121 29 52 26 42 72 218 164 216 62 197 52 15 64 131 201 49 53 74 179 206 35 55 220 14 178 119 207 33 173 123 7 169 168 30 74 90 82 172 160 186 123 20 148 22 37 169 151 75 79 111 111 47 39 21 173 138 25 245 161 143 196 122 69 91 19 26 158 229 224 159 120 7 188 136 176 194 203 112 11 60 255 203 26 242 154 39 208 76 179 165 201 52 253 1 64 67 60 109 149 197 120 151 118 10 149 73 14 40 79 60 129 55 9 182 40 77 114 193 219 204 64 188 187 115 5 252 39 55 33 120 243 4 13 181 85 16 19 152 68 76 219 175 68 2 169 180 17 141 82 41 26 169 94 26 170 254 70 101 81 60 202 146 156 240 150 108 188 141 183 197 155 184 227 40 187 98 131 215 49 71 80 122 229 40 196 207 210 48 53 62 68 51 106 102 0 216 197 216 64 23 4 185 1 168 185 225 134 119 233 46 168 74 113 68 69 178 3 42 174 218 163 130 12 149 39 218 161 156 128 222 38 216 161 52 193 1 101 41 110 120 157 29 130 178 219 52 217 131 155 120 117 47 11 175 50 67 80 158 234 202 141 175 190 230 138 234 235 167 169 119 161 251 83 168 74 117 68 85 50 217 74 58 73 54 109 209 240 52 149 34 49 49 11 160 153 132 188 44 7 245 183 2 81 151 231 135 218 28 111 240 179 60 80 147 233 142 234 12 30 103 140 131 74 115 70 101 138 19 42 153 33 6 71 125 85 170 19 202 174 58 34 206 217 8 183 66 15 130 159 125 6 2 26 95 151 235 75 242 67 29 93 11 114 188 192 159 181 85 87 24 10 165 248 13 166 167 70 41 1 148 2 230 189 186 91 10 81 113 56 196 119 195 32 46 10 65 195 157 96 212 23 6 161 190 32 16 194 252 0 8 9 170 238 166 47 103 152 159 229 201 69 169 58 131 121 232 10 62 41 195 203 20 209 14 155 224 190 239 55 68 157 50 65 13 69 82 76 54 68 164 6 114 74 152 71 54 138 194 161 146 85 146 215 180 36 89 33 206 54 29 118 211 193 127 4 201 163 24 136 75 34 32 189 127 145 20 14 201 61 166 11 16 23 19 212 221 80 14 76 116 231 60 25 12 34 131 254 228 157 15 4 217 158 120 25 119 18 97 135 215 32 254 212 22 4 254 185 1 118 59 86 194 125 255 26 60 75 226 145 83 161 120 153 204 195 229 19 155 241 56 47 133 252 157 171 253 15 219 2 69 128 128 52 83 180 78 71 48 210 215 129 178 156 16 188 74 114 134 160 32 8 141 4 212 248 32 18 82 38 186 150 16 156 164 152 160 24 204 173 115 20 29 63 196 187 108 199 197 99 250 72 226 109 71 248 241 223 97 111 252 35 108 182 174 128 237 182 239 17 110 187 17 238 230 255 129 155 201 247 120 92 144 60 111 51 250 112 88 88 176 12 89 57 22 199 122 34 254 184 30 18 237 13 112 221 205 8 69 231 45 241 60 142 114 157 237 195 121 36 229 162 18 10 209 237 96 60 141 117 192 5 27 125 196 158 50 66 154 135 41 34 108 13 192 219 181 10 174 230 63 35 192 106 53 2 44 127 131 215 174 149 224 153 172 32 128 212 69 119 67 45 128 123 113 94 72 60 177 1 201 78 6 72 119 54 196 53 215 141 184 126 122 51 167 12 119 35 20 6 237 199 211 104 59 188 73 227 33 239 172 37 82 61 205 144 233 183 7 25 103 204 200 99 125 132 89 175 199 5 235 13 8 57 188 22 254 127 172 250 118 128 146 4 111 164 208 228 215 92 55 225 6 77 152 233 177 29 89 158 59 144 237 53 163 92 223 157 40 8 220 135 219 33 86 40 142 56 130 251 145 54 40 137 180 70 134 143 57 165 98 61 194 109 24 192 58 4 255 201 0 126 229 0 78 83 4 158 228 211 178 91 36 6 90 17 120 120 213 23 233 46 27 113 195 99 27 114 188 119 32 207 215 20 121 126 102 200 247 55 71 126 192 46 20 158 219 135 162 208 3 184 127 201 26 15 162 108 241 48 250 4 74 46 31 35 128 93 52 249 58 14 32 236 232 28 192 47 240 100 0 198 84 3 249 41 95 7 240 128 3 216 140 76 79 2 240 53 65 174 255 236 228 129 187 144 31 180 27 133 193 22 40 186 112 8 247 8 160 36 202 14 247 73 197 20 133 107 103 118 206 0 80 10 194 142 232 33 248 224 26 248 89 172 226 138 208 197 248 59 60 34 128 197 154 86 4 238 39 156 65 178 35 229 158 183 5 55 188 40 252 222 38 200 246 49 69 182 175 25 114 40 10 185 103 247 162 128 194 127 59 252 48 138 46 29 199 29 210 173 240 35 72 241 52 229 0 88 248 67 143 172 69 208 193 213 240 217 247 51 120 102 63 192 105 219 191 241 48 143 86 193 34 57 88 240 107 200 142 99 119 174 120 32 214 110 29 174 58 26 32 217 101 19 82 93 183 32 141 103 132 116 247 109 72 167 90 200 240 166 162 11 216 139 155 193 7 144 27 122 24 55 73 217 193 7 145 200 51 166 201 245 184 201 207 29 90 13 127 75 202 255 238 149 228 253 10 216 111 253 23 174 69 5 97 144 78 77 83 147 147 180 236 231 237 3 115 151 83 147 19 232 167 83 80 118 136 61 46 31 93 141 168 227 235 17 99 71 75 236 164 1 98 237 127 71 156 131 33 226 156 54 34 193 197 8 73 238 38 72 245 222 131 116 63 11 164 251 255 129 84 223 253 136 113 222 206 85 126 48 77 30 64 147 51 239 221 201 123 71 218 15 156 246 26 162 32 35 17 205 50 41 70 71 71 180 1 216 161 145 253 118 75 26 4 72 143 14 129 191 173 25 124 173 214 34 148 12 70 28 213 35 81 79 222 69 28 219 128 72 59 67 68 57 108 69 140 203 14 196 185 237 68 188 187 57 215 95 58 185 153 11 251 220 228 30 230 43 225 104 250 19 206 185 217 226 249 195 98 200 91 155 48 198 38 159 94 184 27 190 79 1 131 24 31 27 133 138 126 243 197 245 124 60 45 41 68 98 100 16 206 59 31 132 247 33 67 248 88 174 161 194 90 77 80 122 8 163 205 231 226 137 77 184 228 176 13 145 142 219 169 55 66 40 61 243 181 248 5 94 123 126 130 27 21 158 251 129 45 200 74 142 134 80 80 141 1 10 253 167 78 198 218 39 34 110 107 214 112 231 249 145 225 33 40 58 219 80 91 93 129 187 249 25 136 14 246 128 223 201 125 240 56 160 15 191 195 6 8 177 49 196 249 99 27 57 157 61 164 135 51 187 127 132 179 249 175 184 232 227 128 210 23 79 161 232 104 3 59 15 50 123 95 121 42 158 251 112 225 0 102 96 146 106 100 72 61 128 246 214 102 84 190 126 129 156 180 56 68 248 56 194 251 152 25 188 172 244 41 66 107 225 105 109 140 91 153 41 104 20 11 49 52 52 200 121 253 165 191 136 139 30 203 63 247 87 134 203 32 25 158 24 31 163 208 170 208 210 212 136 154 242 82 252 253 164 24 50 169 8 3 125 189 152 156 152 252 234 63 167 255 3 153 244 233 15 36 134 199 179 0 0 0 0 73 69 78 68 174 66 96 130] 0 0 4034 4097 4066 1 1602 8 #openTraitBrowser 8 'Trait Browser' 1 1 4418 4450 0 16 4482 0 8 #[137 80 78 71 13 10 26 10 0 0 0 13 73 72 68 82 0 0 0 32 0 0 0 32 8 6 0 0 0 115 122 122 244 0 0 0 1 115 82 71 66 0 174 206 28 233 0 0 0 4 103 65 77 65 0 0 177 143 11 252 97 5 0 0 0 32 99 72 82 77 0 0 122 38 0 0 128 132 0 0 250 0 0 0 128 232 0 0 117 48 0 0 234 96 0 0 58 152 0 0 23 112 156 186 81 60 0 0 0 9 112 72 89 115 0 0 3 175 0 0 3 175 1 24 30 177 125 0 0 9 161 73 68 65 84 88 71 237 151 121 80 20 87 30 199 77 54 76 195 0 195 229 0 130 2 42 160 128 136 136 32 8 145 224 17 143 168 200 13 202 0 130 128 28 3 10 131 48 28 194 12 32 3 3 50 224 72 0 145 91 68 24 240 0 68 131 49 145 96 36 4 48 196 219 40 176 90 70 77 76 220 53 42 166 103 250 91 219 36 181 127 100 117 3 181 85 251 215 238 171 234 234 238 170 239 123 223 207 251 246 175 187 223 155 49 227 255 141 78 192 193 97 61 107 79 170 248 220 161 234 54 30 125 251 206 127 43 148 15 54 250 47 207 200 43 175 18 136 202 214 253 193 195 218 218 69 107 179 95 228 235 194 131 71 33 235 232 59 95 81 209 162 241 103 16 198 198 174 154 30 219 15 217 135 68 247 184 199 36 116 111 113 112 225 91 210 122 165 183 245 113 117 117 125 111 71 36 223 215 47 132 215 31 155 152 75 143 127 9 169 194 242 140 55 180 222 129 241 173 254 193 123 40 233 225 54 156 191 56 50 80 209 210 243 7 136 89 179 236 152 78 31 30 222 33 40 190 251 69 97 237 203 137 138 19 128 164 137 132 180 249 23 42 175 90 1 55 207 211 79 149 180 34 59 204 108 132 17 108 75 31 53 31 159 104 181 248 148 162 184 200 61 194 209 224 168 180 159 184 9 194 129 174 243 195 56 88 217 122 119 211 166 77 204 55 0 124 125 35 55 114 194 247 254 26 16 188 203 191 238 248 185 159 6 71 238 14 180 244 12 78 66 188 179 216 165 200 127 253 182 27 99 222 177 175 21 31 120 143 41 66 146 95 83 251 143 0 73 69 19 20 135 219 171 72 200 30 148 119 13 0 78 235 142 200 173 157 202 228 115 23 75 30 133 114 235 159 133 197 164 93 9 11 75 219 145 201 43 208 239 187 124 227 90 125 75 207 131 112 110 218 252 183 166 235 58 131 142 42 34 245 59 159 237 177 1 41 25 197 203 79 116 95 154 248 114 232 246 85 167 149 59 107 53 244 188 95 238 76 26 147 251 199 203 229 219 120 20 149 88 4 172 242 29 146 187 108 238 151 115 146 158 42 172 86 52 147 65 113 95 202 215 108 61 77 105 26 139 161 58 59 149 134 233 80 8 37 183 90 162 163 51 245 135 190 29 189 212 214 213 247 40 129 159 187 240 79 235 139 19 154 184 43 40 138 255 233 164 40 85 88 22 33 235 250 10 95 13 223 68 117 77 247 175 25 37 175 168 93 2 32 130 62 226 10 41 248 198 94 87 56 251 62 148 239 171 34 33 170 127 73 89 174 232 130 174 69 19 8 163 98 16 134 2 152 47 77 167 210 114 122 20 131 35 99 79 219 206 94 250 33 51 179 108 209 148 197 77 23 151 114 120 76 230 247 65 81 73 110 202 44 135 202 252 3 141 24 255 235 125 140 143 143 227 194 197 235 168 235 156 128 168 6 16 55 3 89 245 192 1 25 133 250 47 128 148 67 20 114 171 41 216 111 248 26 26 230 50 188 191 185 17 159 127 214 143 193 161 235 56 209 221 143 173 126 66 233 148 230 255 20 112 118 238 77 240 242 231 61 96 176 156 228 171 215 71 227 108 247 121 60 249 225 49 110 221 186 141 246 178 122 200 78 63 69 91 31 144 113 16 104 252 12 56 119 5 200 174 124 6 179 149 35 80 55 239 69 80 220 32 134 190 185 134 209 209 7 184 115 119 20 197 210 99 207 55 7 156 36 253 195 187 63 154 22 132 165 165 165 154 129 201 154 215 26 236 141 208 50 240 195 94 126 41 100 39 58 240 224 225 143 56 114 178 1 159 231 21 211 231 191 163 135 46 186 231 36 208 59 248 43 44 87 118 96 142 117 57 132 69 195 104 47 204 198 141 91 227 24 26 30 198 201 246 46 188 255 97 49 105 97 39 149 239 226 223 25 162 1 254 50 37 132 10 203 206 129 165 227 74 233 24 120 129 61 39 28 43 86 75 32 147 125 137 114 65 22 234 143 93 64 105 101 17 78 125 114 1 167 232 232 73 5 29 191 228 21 220 188 207 131 47 104 65 87 101 41 234 142 157 71 85 75 61 90 91 218 17 199 107 135 225 2 9 165 170 23 67 242 242 94 40 86 111 218 111 63 37 128 241 2 143 124 125 35 79 82 207 208 15 108 163 112 44 88 34 68 73 29 137 51 167 46 162 84 148 133 188 220 12 136 170 191 195 167 215 129 163 29 114 36 28 152 192 106 191 115 8 12 75 64 114 114 28 210 11 4 40 224 241 176 193 41 17 70 11 243 161 107 86 67 17 58 113 242 212 162 95 228 238 156 51 217 83 2 40 179 108 123 52 217 174 164 150 190 143 92 135 78 64 69 135 131 117 94 39 81 126 98 2 101 85 181 208 95 152 9 11 183 62 108 8 27 5 55 239 25 2 98 174 193 118 109 43 244 44 242 224 229 23 9 113 193 94 172 181 13 6 83 55 2 250 243 120 32 12 10 40 29 99 49 25 204 253 154 252 40 224 211 142 41 1 84 212 109 70 9 245 101 164 18 107 13 201 156 233 71 233 206 75 134 129 213 73 84 158 166 208 212 122 19 132 94 14 182 112 62 193 106 159 43 40 44 31 131 59 167 23 134 86 18 152 216 54 194 100 241 97 232 155 38 130 208 141 133 254 252 76 40 179 131 233 235 40 138 208 77 39 157 215 181 146 118 171 100 55 166 4 80 98 90 220 87 211 118 38 25 154 27 72 66 199 155 34 216 33 32 244 247 194 212 94 134 130 163 114 164 148 253 132 132 172 171 244 199 38 19 26 38 98 88 59 215 33 45 231 46 108 236 143 96 190 205 199 208 52 22 128 193 78 132 161 105 46 8 157 237 96 234 69 80 90 38 37 164 233 162 20 210 206 173 105 108 26 0 102 227 234 58 46 36 161 185 158 36 102 110 167 1 130 64 204 206 7 219 246 54 152 11 191 129 83 192 207 40 108 120 137 149 190 159 209 31 29 49 88 38 18 204 93 92 11 115 155 26 48 245 51 160 61 55 31 110 31 117 192 192 252 0 102 89 29 131 182 113 54 148 245 210 73 53 157 45 164 146 134 231 237 105 0 152 95 102 168 90 145 218 250 62 36 161 181 149 6 8 135 178 105 51 116 237 239 64 217 98 24 76 203 107 176 94 247 24 222 113 79 224 177 115 4 241 226 87 16 84 144 200 60 248 4 249 210 123 208 53 225 193 98 89 13 136 153 33 80 54 200 7 193 142 130 234 172 44 146 169 181 150 100 104 184 247 77 9 240 158 202 188 195 12 85 75 146 96 185 146 108 195 16 138 208 246 163 103 90 1 23 55 25 36 82 17 22 185 228 67 197 232 8 44 28 79 225 131 173 23 208 241 21 80 213 9 240 10 0 105 195 61 156 190 112 31 123 115 238 129 161 53 249 252 35 233 154 73 129 166 145 136 100 168 187 77 78 168 100 74 0 37 85 115 63 6 211 76 206 96 57 146 42 90 27 40 61 227 4 152 25 122 66 24 183 7 251 132 124 100 100 69 195 210 97 15 29 119 58 36 13 47 144 67 255 21 19 104 243 90 89 63 74 164 89 168 20 9 209 120 122 20 81 201 35 8 227 118 194 218 177 2 132 54 71 193 208 220 44 87 209 112 246 152 18 96 198 108 71 21 37 101 179 239 25 106 75 73 66 99 45 229 250 97 50 82 19 82 80 215 218 140 164 148 124 8 146 98 233 119 94 4 43 122 224 114 25 61 235 38 96 95 241 35 52 52 138 145 91 152 135 146 67 173 200 227 114 113 168 238 42 74 235 228 48 95 34 2 161 238 64 67 120 63 158 49 195 81 101 106 0 90 161 172 182 100 159 42 107 25 105 189 52 128 106 104 60 134 254 254 1 180 200 186 16 27 224 143 160 48 49 76 172 69 152 99 149 137 40 254 183 212 158 253 192 228 145 18 95 1 1 55 14 77 39 219 209 123 105 24 71 155 154 145 153 93 245 187 185 250 114 202 196 204 245 204 180 204 127 19 209 41 188 167 108 54 44 145 148 253 210 219 219 135 203 151 191 134 184 184 4 91 60 120 80 158 25 8 246 220 56 44 114 42 82 172 241 108 37 107 59 40 170 229 44 16 153 250 26 219 252 246 65 144 186 15 87 70 190 193 213 145 171 40 171 108 192 218 245 156 87 42 44 155 27 219 194 146 94 111 241 222 49 185 116 155 94 243 244 221 189 185 174 185 27 23 62 239 67 213 225 90 184 123 198 128 161 185 5 236 217 17 80 55 59 74 233 47 255 150 156 183 250 30 105 180 242 38 153 92 58 65 5 243 21 148 71 216 35 69 118 78 233 139 154 234 122 156 234 186 136 242 154 78 120 250 198 63 97 168 217 90 4 70 36 55 197 243 246 87 76 203 93 152 95 181 160 188 225 204 67 73 69 219 223 162 98 83 111 217 47 119 87 16 234 78 96 176 86 129 161 177 9 218 102 109 164 138 233 89 82 117 193 39 164 202 188 179 100 132 144 164 188 118 3 219 118 191 80 184 111 239 25 231 236 8 203 205 22 73 199 62 174 239 68 117 227 185 231 252 220 143 45 189 253 99 87 241 5 210 87 49 49 49 58 127 10 145 46 44 91 32 173 108 127 40 20 87 63 12 10 227 47 38 88 86 243 85 88 14 23 25 204 165 20 161 186 12 12 53 71 57 67 139 67 178 76 59 72 98 206 113 82 219 188 147 228 36 61 167 252 98 31 43 220 3 218 228 218 236 53 36 161 186 244 14 131 185 248 120 96 40 207 171 180 178 253 231 202 218 174 71 60 94 206 18 222 190 226 159 69 133 135 83 254 45 64 84 84 230 188 236 162 218 135 73 25 7 110 110 242 225 24 173 13 12 84 141 77 206 73 10 137 230 63 89 226 232 123 139 161 234 48 160 196 92 66 78 2 48 180 131 73 53 221 88 210 121 99 39 185 49 224 178 220 216 250 160 156 152 25 73 210 160 95 40 169 218 248 210 38 239 78 26 113 185 233 182 249 146 250 31 15 72 143 63 77 72 45 188 91 92 222 122 223 206 206 238 205 37 188 143 143 143 6 47 173 232 90 68 156 0 137 169 249 249 210 138 246 226 236 162 250 31 185 188 220 46 119 223 157 147 27 137 223 54 44 234 51 93 204 149 180 182 134 43 233 165 23 49 102 137 234 22 185 117 214 170 233 5 21 18 26 206 97 44 214 138 183 174 120 253 131 162 173 82 178 164 223 11 197 71 176 191 168 30 185 162 114 207 55 82 240 10 136 105 13 220 153 140 164 12 9 246 139 107 159 165 9 74 37 65 65 188 183 47 161 167 85 73 127 20 5 132 68 154 241 210 11 198 83 133 82 240 51 242 206 253 235 16 239 174 113 231 12 109 244 10 29 240 218 22 19 67 239 102 212 254 3 143 41 187 120 120 108 159 197 229 238 62 22 26 26 122 124 74 241 255 140 224 31 240 253 27 7 14 53 80 88 0 0 0 0 73 69 78 68 174 66 96 130] 0 0 4034 4097 4066 1 1602 8 #openUMLWorkspace 8 'UML Scripts' 1 1 4258 0 16 1712 8 'Shell.ico' 4320 0 0 4034 4097 4066 1 1602 8 #openVirtualMachineBrowser 8 'Virtual Machine Browser' 1 1 4418 4450 0 16 4482 0 8 #[137 80 78 71 13 10 26 10 0 0 0 13 73 72 68 82 0 0 0 32 0 0 0 32 8 6 0 0 0 115 122 122 244 0 0 0 1 115 82 71 66 0 174 206 28 233 0 0 0 4 103 65 77 65 0 0 177 143 11 252 97 5 0 0 0 32 99 72 82 77 0 0 122 38 0 0 128 132 0 0 250 0 0 0 128 232 0 0 117 48 0 0 234 96 0 0 58 152 0 0 23 112 156 186 81 60 0 0 0 9 112 72 89 115 0 0 3 175 0 0 3 175 1 24 30 177 125 0 0 7 203 73 68 65 84 88 71 173 151 11 48 151 123 26 199 75 88 27 91 163 58 118 215 118 186 169 227 116 35 181 211 109 207 140 169 109 35 155 58 154 154 154 105 76 78 199 102 202 65 177 37 169 40 93 84 186 235 34 42 221 168 80 42 209 69 161 230 144 168 13 39 115 50 69 28 196 74 145 203 209 223 229 183 159 199 98 228 236 89 78 199 59 243 140 247 125 255 191 247 247 60 191 239 243 125 190 207 163 71 143 46 92 254 254 254 125 101 153 143 143 143 129 167 167 231 144 46 124 210 61 75 214 172 89 51 235 228 201 147 122 30 30 30 233 235 215 175 119 88 187 118 109 250 156 57 115 130 55 109 218 244 205 226 197 139 253 187 199 203 255 216 197 219 219 219 196 222 222 126 208 202 149 43 27 57 113 17 8 168 93 187 118 169 205 155 55 43 156 43 63 63 63 101 103 103 247 47 222 251 57 57 57 205 239 214 64 44 45 45 245 92 93 93 27 57 109 77 92 92 156 202 207 207 175 139 143 143 255 254 232 209 163 117 135 14 29 82 23 47 94 204 59 123 246 108 227 158 61 123 212 198 141 27 213 180 105 211 254 217 109 1 0 249 74 103 103 231 144 189 123 247 170 151 47 95 54 28 63 126 60 161 127 255 254 190 35 71 142 220 38 239 56 121 14 206 156 45 44 44 246 19 192 235 195 135 15 171 221 187 119 191 217 190 125 123 68 119 4 161 181 116 233 210 176 125 251 246 169 188 188 188 42 91 91 219 67 108 58 7 251 253 206 157 59 207 158 62 125 90 205 159 63 127 43 207 191 197 76 39 77 154 180 11 36 212 129 3 7 26 172 173 173 125 120 215 243 163 131 128 221 198 171 87 175 142 246 242 242 250 241 217 179 103 26 27 27 155 0 54 27 125 228 200 145 63 133 132 132 196 66 196 134 160 160 160 55 58 58 58 102 173 78 140 141 141 199 93 190 124 89 69 68 68 52 238 223 191 63 53 56 56 184 223 71 7 192 135 6 14 14 14 137 97 97 97 10 71 55 116 117 117 77 113 108 129 227 123 79 158 60 17 39 133 199 142 29 107 28 51 102 204 231 173 78 214 173 91 55 238 246 237 219 234 234 213 171 106 219 182 109 25 203 150 45 27 244 81 1 112 122 93 119 119 247 128 13 27 54 52 224 72 241 55 157 19 21 73 48 242 124 226 196 137 18 78 87 112 227 198 13 69 222 219 24 127 229 202 21 143 148 148 20 117 233 210 165 55 67 134 12 113 195 121 95 72 251 199 214 32 162 162 162 6 118 41 32 88 175 109 102 102 22 68 233 53 1 121 243 137 146 146 146 52 56 255 158 192 18 128 185 33 35 35 163 145 231 202 71 143 30 213 164 165 165 253 93 180 129 251 220 199 143 31 171 135 15 31 170 243 231 207 95 164 82 204 238 222 189 91 196 183 159 242 141 35 252 200 146 0 210 211 211 117 224 201 196 159 13 102 212 168 81 186 212 114 92 64 64 128 148 88 253 194 133 11 195 13 12 12 132 84 142 152 157 161 161 161 159 152 190 190 190 239 185 115 231 74 95 188 120 161 121 254 252 121 28 68 85 215 174 93 43 122 250 244 105 83 114 114 114 90 106 106 234 3 65 132 32 242 99 99 99 155 162 163 163 21 165 235 121 234 212 169 23 91 183 110 189 250 179 1 44 90 180 200 120 222 188 121 79 129 190 158 188 43 16 249 138 197 70 152 54 166 133 9 172 127 192 140 9 204 19 78 212 150 148 148 168 162 162 34 169 150 166 130 130 2 37 60 1 114 73 135 34 72 117 231 206 29 69 138 154 223 201 179 175 175 239 29 208 181 33 181 222 16 221 178 99 48 125 135 13 27 182 30 152 234 129 86 145 251 71 164 225 3 66 9 140 8 146 109 110 110 110 106 117 117 181 42 47 47 87 53 53 53 74 156 83 61 77 19 38 76 200 54 53 53 13 31 60 120 112 32 14 190 77 76 76 84 179 103 207 206 66 39 114 64 73 133 134 134 10 185 213 142 29 59 20 186 50 253 39 104 56 58 58 126 141 0 253 64 132 213 2 221 205 155 55 53 247 239 223 191 71 126 47 80 150 241 133 133 133 111 43 42 42 212 235 215 175 149 4 240 246 237 91 69 80 202 196 196 164 148 138 57 204 134 130 218 100 236 51 224 207 148 131 112 191 10 251 199 204 153 51 131 65 166 130 42 82 110 110 110 229 51 102 204 176 2 25 163 132 132 4 65 184 237 50 215 210 210 114 35 5 181 103 206 156 169 191 117 235 86 195 131 7 15 84 86 86 150 192 44 121 173 195 121 35 100 171 211 104 52 141 217 217 217 106 192 128 1 121 124 237 129 141 106 73 87 15 14 48 16 114 54 185 184 184 148 240 78 170 64 23 51 31 59 118 236 230 240 240 240 42 145 114 145 112 82 162 166 76 153 34 65 183 93 146 235 62 112 225 12 2 179 3 198 191 225 131 114 154 205 61 200 165 104 76 151 57 197 119 153 153 153 117 181 181 181 13 83 167 78 173 96 189 11 214 38 62 148 179 22 208 11 71 100 243 232 22 231 173 14 6 45 95 190 60 84 170 76 154 26 122 242 132 31 198 116 76 133 14 47 254 130 153 80 9 71 9 196 27 210 45 32 53 241 188 179 4 242 88 197 69 122 4 222 19 216 128 214 13 114 114 114 6 194 145 76 254 42 41 77 58 232 222 142 155 107 107 107 79 134 19 149 84 132 98 255 24 210 62 180 227 154 214 103 209 244 63 99 194 126 3 204 10 211 231 212 203 223 189 123 87 183 106 213 170 247 60 79 109 93 140 99 67 42 2 210 95 81 35 70 140 120 142 147 18 120 240 138 223 5 213 246 87 111 80 74 150 20 72 123 71 73 53 240 65 74 189 211 171 39 117 191 172 180 180 180 2 248 21 109 250 7 248 241 53 100 12 172 172 172 204 160 34 26 139 139 139 21 45 92 56 225 68 71 141 188 126 253 186 234 221 187 119 155 42 182 120 232 73 133 132 137 222 48 204 104 250 245 235 23 203 123 243 78 189 179 160 39 144 217 163 110 133 82 126 56 85 85 85 85 170 172 172 76 197 196 196 40 28 54 4 6 6 150 3 253 143 48 27 26 36 190 71 21 85 100 100 100 20 72 252 166 189 3 6 154 24 225 0 125 39 155 234 145 78 43 8 119 122 73 74 70 35 203 167 165 238 33 104 147 149 149 85 62 202 152 196 251 80 204 135 205 60 105 70 223 49 186 213 3 107 41 78 94 73 167 68 83 110 163 174 173 78 180 129 190 148 214 174 132 7 12 51 201 220 139 192 117 126 33 181 182 148 164 6 77 16 249 173 199 161 59 95 125 137 89 96 162 154 134 152 61 230 133 185 246 233 211 199 19 168 139 100 94 96 168 73 57 120 240 96 127 82 103 195 240 162 224 144 154 53 107 86 181 185 185 121 22 58 34 252 234 252 226 196 14 164 33 5 49 41 163 49 137 178 121 74 106 58 124 41 85 36 129 200 192 242 9 58 225 46 65 136 0 145 162 44 78 155 38 240 19 64 9 154 35 223 11 1 77 58 247 254 95 71 163 177 133 64 250 82 26 14 29 175 154 252 138 0 253 191 235 19 35 35 35 119 28 23 35 80 50 186 53 179 127 203 150 45 66 88 105 223 189 186 226 188 109 13 115 193 223 100 0 185 112 225 130 146 217 0 61 40 192 126 34 38 237 55 165 205 127 198 137 31 75 233 81 118 117 211 167 79 207 101 218 250 55 163 125 30 37 249 129 20 119 26 12 131 168 53 165 21 201 194 96 84 242 189 52 25 106 191 14 93 15 226 249 175 162 239 168 160 62 121 31 140 164 127 137 30 132 144 251 119 50 204 10 244 200 239 123 160 255 134 239 133 63 34 195 31 84 72 167 1 176 64 58 228 23 195 135 15 159 73 137 41 166 36 217 88 250 67 115 203 149 161 21 148 148 228 92 36 23 231 74 156 35 227 197 40 99 131 64 63 119 238 220 113 45 28 249 29 127 59 10 85 87 98 128 226 174 174 95 0 225 43 61 61 189 8 54 143 99 224 104 118 196 200 94 199 0 34 132 83 43 86 172 40 19 216 229 228 144 113 103 175 94 189 252 39 78 156 152 4 153 165 246 127 245 245 41 59 56 11 26 75 150 44 113 17 39 204 1 223 50 19 4 49 83 40 52 190 154 223 188 22 44 88 144 36 93 143 123 153 164 5 189 185 216 240 95 237 189 133 189 122 178 17 167 154 140 115 105 86 118 152 57 141 43 99 232 208 161 81 220 139 192 216 142 31 63 94 56 211 218 49 165 154 126 25 243 187 16 173 116 68 235 22 66 105 211 61 157 184 23 113 17 103 162 11 50 164 252 98 178 117 193 239 7 75 218 11 146 4 212 94 223 59 253 111 233 63 1 82 118 13 51 215 186 14 0 0 0 0 73 69 78 68 174 66 96 130] 0 0 4034 4097 4066 1 1602 8 #showWebConfiguration 8 'Web Server Configuration' 1 1 4258 0 16 1712 8 'SMALLTALKOPTIONSFOLDER.ICO' 4320 0 0 4066 1 1602 8 #startWebLogin 8 'Web login' 1 1 4258 0 16 1712 29 4314 8 'shell32.dll' 0 0 0 4034 4097 4066 1 1602 8 #startDesktopLogin 8 'Desktop login' 1 1 4258 0 16 1712 8 'TextEdit.ico' 4320 0 0 8 'Tools' 0 134217729 0 0 28999 0 0 8 '' 0 134217729 0 0 0 0 0 0 0 0 1 0 0 0 0 1 0 0 898 202 208 98 3 962 992 98 2 1026 3199 21 1026 1991 1291 416 962 8 #text: 98 1 8 'UML Working Space' 416 962 8 #updateMenuBar 1120 416 1074 8 #[44 0 0 0 0 0 0 0 0 0 0 0 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 63 6 0 0 10 0 0 0 34 10 0 0 143 2 0 0] 98 2 544 2912 1136 0 27 )! !
!UMLIdeaSpaceShell class categoriesFor: #icon!public! !
!UMLIdeaSpaceShell class categoriesFor: #resource_Default_view!public!resources-views! !

